#include <math.h>
#include <string.h>

#include "gba.h"
#include "screenmode.h"
#include "keys.h"
#include "sprite.h"
#include "colorsfx.h"
#include "fixmath.h"

#include "guz.h"

#include "gfx/sprite8x8.h"
#include "gfx/background2.h"

#define PREC 8
#define ever ;;

// globals
s16 x = 60;
s16 y = 10;

FIXED angle = 0;
FIXED zoom = FIX(1,PREC);

FIXED SIN_TABLE[360];
FIXED COS_TABLE[360];

u16 compteur;

void DMA3Call(u32 Src,u32 Dst,u32 Cnt)					//used to load our sprite info into vram
{
	REG_DM3SAD = Src;									//where the data is
	REG_DM3DAD = Dst;									//where the data goes
	REG_DM3CNT = Cnt;									//how much data should be loaded
}

void CopyBkg( int x, int y )
{
	// x,y is picture coordinates of 0,0 point on screen
	int line = 0;

	for( line=0; line<160; line++)
		DMA3Call((u32)&background_Map+(line+y)*320 + x, (u32)VideoBuffer + (line*240), 0x8400003C );	//DMA Sprite Graphics
}

void moveScreen()
{
	int y;

	y = -60*cos(RADIAN((compteur)*3))/* + -20*sin(RADIAN(compteur))*/ - 80;
	y += 160;
	
	CopyBkg( 0, y );
}

void C_Entry(void)
{
	int i = 0;
	int j = 0;
	int line = 0;
	int rline = 0;
	
	int x;
	int y;

	for(i = 0; i < 360; i++)
	{
		SIN_TABLE[i] = FIX(sin(RADIAN(i)), PREC);
		COS_TABLE[i] = FIX(cos(RADIAN(i)), PREC);
	}

	SetMode(MODE_4 | OBJ_ENABLE | OBJ_MAP_1D | BG2_ENABLE);

//	memcpy( OBJPaletteMem, sprite_Palette, 256 * 2 );						// setup obj palette
//	memcpy( BGPaletteMem, background_Palette, 256 * 2 );					// setup background palette
//	memcpy( VideoBuffer, background_Map, 160 * 240 * 2 );					// setup background

	DMA3Call((u32)&sprite_Palette, (u32)OBJPaletteMem, 0x84000020 );		//DMA Sprite Palette
	DMA3Call((u32)&background_Palette, (u32)BGPaletteMem, 0x84000020 );		//DMA BackGround Palette
//	DMA3Call((u32)&background_Map, (u32)VideoBuffer, 0x84002580 );		//DMA Sprite Graphics
	
	CopyBkg( 0, 0 );

	initSprites(); // clear sprite memory

	for( line=0; line < 5; line ++ )
	{
		for( i=0; i<5; i++ )
		{
			sprites[i+line*10].attribute0 = COLOR_256 | SQUARE | MODE_NORMAL;
			sprites[i+line*10].attribute1 = SIZE_32;

			sprites[i+line*10].attribute0 = sprites[i+line*10].attribute0 & 0xFF00;
			sprites[i+line*10].attribute0 = sprites[i+line*10].attribute0 | 160;
			
			sprites[i+line*10].attribute1 = sprites[i+line*10].attribute1 & 0xFE00;
			sprites[i+line*10].attribute1 = sprites[i+line*10].attribute1 | 240;

			sprites[i+line*10].attribute2 = 0x40 + ((i+line*5) * 0x20);
		}
		
		j = 4;

		for( i=5; i<10; i++ )
		{
			sprites[i+line*10].attribute0 = COLOR_256 | SQUARE | MODE_NORMAL;
			sprites[i+line*10].attribute1 = SIZE_32 | HORIZONTAL_FLIP;

			sprites[i+line*10].attribute0 = sprites[i+line*10].attribute0 & 0xFF00;
			sprites[i+line*10].attribute0 = sprites[i+line*10].attribute0 | 160;
			
			sprites[i+line*10].attribute1 = sprites[i+line*10].attribute1 & 0xFE00;
			sprites[i+line*10].attribute1 = sprites[i+line*10].attribute1 | 240;

			sprites[i+line*10].attribute2 = 0x40 + ((j+line*5) * 0x20);
			j--;
		}
	}
	
	rline = 4;
	
	for( line=5; line < 10; line++ )
	{
		for( i=0; i<5; i++ )
		{
			sprites[i+line*10].attribute0 = COLOR_256 | SQUARE | MODE_NORMAL;
			sprites[i+line*10].attribute1 = SIZE_32 | VERTICAL_FLIP;

			sprites[i+line*10].attribute0 = sprites[i+line*10].attribute0 & 0xFF00;
			sprites[i+line*10].attribute0 = sprites[i+line*10].attribute0 | 160;
			
			sprites[i+line*10].attribute1 = sprites[i+line*10].attribute1 & 0xFE00;
			sprites[i+line*10].attribute1 = sprites[i+line*10].attribute1 | 240;

			sprites[i+line*10].attribute2 = 0x40 + ((i+rline*5) * 0x20);
		}

		j = 4;

		for( i=5; i<10; i++ )
		{
			sprites[i+line*10].attribute0 = COLOR_256 | SQUARE | MODE_NORMAL;
			sprites[i+line*10].attribute1 = SIZE_32 | HORIZONTAL_FLIP | VERTICAL_FLIP;

			sprites[i+line*10].attribute0 = sprites[i+line*10].attribute0 & 0xFF00;
			sprites[i+line*10].attribute0 = sprites[i+line*10].attribute0 | 160;
			
			sprites[i+line*10].attribute1 = sprites[i+line*10].attribute1 & 0xFE00;
			sprites[i+line*10].attribute1 = sprites[i+line*10].attribute1 | 240;

			sprites[i+line*10].attribute2 = 0x40 + ((j+rline*5) * 0x20);
			j--;
		}
		
		rline--;
	}

	memcpy( OAMData+1024, sprite_Data, 25 * 1024 ); // copy sprite bitmap to OAM
	copyOAM();

	REG_BLDMOD = BLDMOD_TARG1_OBJ | BLDMOD_SFX_MODE(MODE_NONE) | BLDMOD_TARG1_OBJ;
	BLEND(25, 12); // setup alpha blending

	//REG_DISPCNT |= 0x10;

	for( ever )
	{
		moveScreen();
		moveSprite( &sprites[0], x, y );
		
		copyOAM();
		
		waitForVsync();
	}
}

void initSprites(void)
{
	int loop;

	memset(sprites, 0, sizeof(sprites) / sizeof(sprites[0]));

    for( loop=0; loop<128; loop++ )
    {
		sprites[loop].attribute0 = sprites[loop].attribute0 & 0xFF00;
		sprites[loop].attribute0 = sprites[loop].attribute0 | 160;
		sprites[loop].attribute1 = sprites[loop].attribute1 & 0xFE00;
		sprites[loop].attribute1 = sprites[loop].attribute1 | 240;
    }
}

void copyOAM(void)
{
	DMA3Call((u32)&sprites, (u32)OAM, 0x84000100 );	//DMA Sprite Graphics
}

void waitForVsync(void)
{
	__asm
	{
			mov		r0, #0x4000006
		scanline_wait:
			ldrh	r1, [r0]
			cmp		r1, #160
			bne		scanline_wait
	}
}

void moveSprite(OAMEntry* p, int x, int y)
{
	u16 line=0;
	u16 sprite=0;
	int xsaved;

	// Calcul de x et y
	compteur++;
/*
	xsaved = x = 30*cos(RADIAN(compteur*5)) - 15*cos(RADIAN(compteur)) - 40;
	y = 30*sin(RADIAN((compteur+1)*5)) + 20*sin(RADIAN(compteur)) - 80;
*/
	xsaved = x = 45*cos(RADIAN(compteur*3)) - 40;
	y = 50*sin(RADIAN((compteur+1)*5)) - 80;
		
	for( line=0; line<10; line++ )
	{
		for( sprite=0; sprite<10; sprite++ )
		{
			if( ( x<240 && x>-32) && ( y<160 && y>-32) )
			{				
				p->attribute1 = p->attribute1 & 0xFE00;
				
				if(x < 0)
					p->attribute1 = p->attribute1 | (x+512);
				else
					p->attribute1 = p->attribute1 | x;
				
				p->attribute0 = p->attribute0 & 0xFF00;
			
				if(y < 0)
					p->attribute0 = p->attribute0 | (y+256);
				else
					p->attribute0 = p->attribute0 | y;
			}
			else
			{
				p->attribute1 = p->attribute1 & 0xFE00;
				p->attribute1 = p->attribute1 | 240 ;

				p->attribute0 = p->attribute0 & 0xFF00;
				p->attribute0 = p->attribute0 | 160;
			}

			p = p+1;
			x = x+32;
		}
	
		x = xsaved;
		y = y+32;
	}
}